/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ProdMarcaDAO;
import com.rjconsultores.ventaboletos.entidad.ProdMarca;
import com.rjconsultores.ventaboletos.entidad.ProdPrecio;
import com.rjconsultores.ventaboletos.service.ProdMarcaService;
import com.rjconsultores.ventaboletos.service.ProdPrecioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("prodMarcaService")
public class ProdMarcaServiceImpl implements ProdMarcaService {

    @Autowired
    private ProdMarcaDAO prodMarcaDAO;
    @Autowired
    private ProdPrecioService prodPrecioService;
    

    public List<ProdMarca> obtenerTodos() {
        return prodMarcaDAO.obtenerTodos();
    }

    public ProdMarca obtenerID(Integer id) {
        return prodMarcaDAO.obtenerID(id);
    }

    @Transactional
    public ProdMarca suscribir(ProdMarca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return prodMarcaDAO.suscribir(entidad);
    }

    @Transactional
    public ProdMarca actualizacion(ProdMarca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return prodMarcaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(ProdMarca entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        prodMarcaDAO.actualizacion(entidad);
    }

    @Transactional
    public ProdMarca actualizacion(ProdMarca entidad, List<ProdPrecio> listPrecios) {
        entidad = this.actualizacion(entidad);
        for(ProdPrecio pp : listPrecios){
            prodPrecioService.actualizacion(pp);
        }
        return entidad;
    }

    @Transactional
    public ProdMarca suscribir(ProdMarca entidad, List<ProdPrecio> listPrecios) {
        entidad = this.suscribir(entidad);
        for(ProdPrecio pp : listPrecios){
            prodPrecioService.suscribir(pp);
        }
        return entidad;
    }
}
